#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

from service import *
from system import NASError
from system import get_name_value
from system import set_name_value

import os
import pwd
from system import chown
from system import WEBUSER
from system import getrealpath
from system import _canwrite
from system import _makesure_dir


DAAPCONF = '/etc/mt-daapd.conf'

KEYS = {'mp3_dir': 'directory',
        'rescan_interval': 'interval'}

VKEYS = {'directory': 'mp3_dir',
         'interval': 'rescan_interval'}

def getdaap(**kw):
    names = { 'port': '',
              'mp3_dir': '',
              'servername': '',
              'password': '',
              'rescan_interval': '',
              'extensions': '',
              'playlist': '', }
    get_name_value(DAAPCONF, names, ['#'], ' ')
    get_name_value(DAAPCONF, names, ['#'], '\t')

    if not names['port'].isdigit():
        names['port'] = '3689'
        set_name_value(DAAPCONF, names, ['#'], '\t')

    result = {}
    for key in names:
        if names[key]:
            newkey = KEYS.get(key) or key
            result[newkey] = names[key]

    result['enable'] = servicestatus('mt-daapd')
    result['running'] = servicerunning('mt-daapd', int(names['port']))
    return result

def setdaap(login=None, enable=None, **kw):

    if enable is None:
        enable = servicestatus('minidlna')
    else:
        enable = str(enable)

    names = {'db_dir': '/home/.nas',
             'port': '',
             'mp3_dir': '',
             'servername': 'isharing'}
    get_name_value(DAAPCONF, names, ['#'], ' ')
    get_name_value(DAAPCONF, names, ['#'], '\t')

    if names['port'].isdigit():
        port = int(names['port'])
    else:
        port = 3689


    names['always_scan'] = '0'
    names['logfile'] = '/home/.nas/mt-daapd.log'
    names['db_dir'] = '/home/.nas'
    names['runas'] = '%s' % WEBUSER
    names['web_root'] = '/usr/share/mt-daapd/admin-root'
    names['admin_pw'] = 'mt-daapd'
    if kw.get('directory') is not None:
        realpath = getrealpath(kw.get('directory'), login, True, system=True)
        if not realpath:
            raise NASError('Invalid Directory')
        names['mp3_dir'] = realpath
    else:
        tmppath = names['mp3_dir']
        if os.path.exists(tmppath) and _canwrite(tmppath):
            pass
        else:
            names['mp3_dir'] = '/home/admin'
            _makesure_dir('/home/admin')

    dbdir = names['db_dir']
    uid = pwd.getpwnam(WEBUSER).pw_uid
    chown(dbdir, uid)

    items = ['servername', 'password', 'interval']
    for item in items:
        if kw.get(item) is not None:
            newkey = VKEYS.get(item) or item
            names[newkey] = str(kw.get(item))

    set_name_value(DAAPCONF, names, ['#'], '\t')

    if enable == 'yes':
        enableservice('mt-daapd')
        restartservice('mt-daapd', 'mt-daapd', port)
    else:
        disableservice('mt-daapd')
        stopservice('mt-daapd')

    return getdaap()

__all__ = ['getdaap', 'setdaap']

# vim: set sta sw=4 et:
