#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

''' iDisk '''

import nas.system

DEVICE = '/etc/nas/device'

def setidisk(enable=None, directory=None, login=None, **kw):
    idisk = {'idisk_enable': 'false'}
    if enable in ('yes', 'true'):
        idisk['idisk_enable'] = 'true'

    if directory is not None:
        realpath = nas.system.getrealpath(directory, login, True)
        idisk['idisk_directory'] = realpath

    nas.system.set_name_value(DEVICE, idisk)

    return getidisk()

def getidisk(**kw):
    idisk = {'idisk_enable': 'false', 'idisk_directory': ''}
    nas.system.get_name_value(DEVICE, idisk)

    names = {}
    names['enable'] = idisk['idisk_enable']
    names['directory'] = idisk['idisk_directory']
    return names

__all__ = ['getidisk', 'setidisk']

# vim: set sta sw=4 et:
