#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 05:14:57 PM CST

''' Reboot or Poweroff '''

from system import POPEN
from system import NASError

def leave(action=None, time=None, **kw):
    if action is None:
        raise NASError('Bad Request')

    action = str(action)
    if action not in ['reboot', 'poweroff']:
        raise NASError('Bad Request')

    if time is not None and str(time).isdigit():
        time = int(str(time))
    else:
        time = 0

    (error, job) = POPEN('echo %s' % action)
    if time == 0:
        (error, pipe) = POPEN('at now', job)
    else:
        (error, pipe) = POPEN('at now + %s minutes' % time, job)

    job.close()
    status = pipe.read()
    pipe.close()
    if error == 0:
        return {'action': 'System will %s in %s minutes' % (action, time)}

    raise NASError('Sytem Error', repr(status))

# vim: set sta sw=4 et:
