#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 12 May 2010 03:38:08 PM CST

''' Samba '''

from service import *
from system import get_name_value
from system import set_name_value
from nas import check_public
from ConfigParser import ConfigParser

SAMBACONF = '/etc/nas/smb.conf'
REALSAMBACONF = '/etc/samba/smb.conf'


def setsmb(enable=None, workgroup=None, **kw):
    if enable is None:
        enable = servicestatus('smb')
    else:
        enable = str(enable)

    if workgroup:
        names = {'workgroup': '%s' % workgroup}
        set_name_value(SAMBACONF, names)

    os.unlink(REALSAMBACONF)
    os.symlink(SAMBACONF, REALSAMBACONF)

    check_public()
    if enable == 'yes':
        enableservice('smb')
        enableservice('nmb')
        restartservice('smb', 'smbd', 139)
        restartservice('nmb', 'nmbd')
    else:
        disableservice('smb')
        disableservice('nmb')
        stopservice('smb')
        stopservice('nmb')
    return getsmb()

def getsmb(**kw):
    names = {'workgroup': None}
    get_name_value(SAMBACONF, names)
    names['enable'] = servicestatus('smb')
    names['running'] = servicerunning('smbd', 139)
    return names

def addsmbdev(path,**kw):
    cf = ConfigParser()
    cf.read(REALSAMBACONF)
    s = cf.sections()
    newname = os.path.basename(path)
    cf.add_section(newname)
    cf.set(newname, 'path', path)
    cf.set(newname, 'writable', 'yes')
    cf.set(newname, 'write list', 'admin')
    cf.set(newname, 'valid users', 'admin')
    cf.set(newname, 'public', 'no')
    cf.set(newname, 'create mask', '0775')
    cf.write(open(REALSAMBACONF, 'w'))
    restartservice('smb', 'smbd', 139)
	
def checksmbpath(path, **kw):
    print "================*********\n path = %s ************\n" % path
    cf = ConfigParser()
    cf.read(REALSAMBACONF)
    s = cf.sections()
    name = os.path.basename(path)
    for n in s:
        print "%s == %s" % (n, name)
        if n != name:
            continue
        else:
            path = cf.get(n,'path')
#            if not os.path.exists(path):
            cf.remove_section(n)
            cf.write(open(REALSAMBACONF, 'w'))	
    restartservice('smb', 'smbd', 139)
__all__ = ['getsmb', 'setsmb', 'addsmbdev', 'checksmbpath']

# vim: set sta sw=4 et:
