#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Tue 13 Jul 2010 12:09:29 AM CST

from system import POPEN
from system import NASError
import leds

def all(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--all', str(device)]
    status = _smartctl(argv)
    return {'all': status}

def info(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--info', str(device)]
    status = _smartctl(argv)
    return {'info': status}

def attributes(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--attributes', str(device)]
    status = _smartctl(argv)
    return {'attributes': status}

def health(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--health', str(device)]
    try:
        status = _smartctl(argv)
    except NASError:
        leds.control(leds.ERROR_LED, leds.ON)
        raise
    return {'health': status}

def capabilities(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--capabilities', str(device)]
    status = _smartctl(argv)
    return {'health': status}

def errorlog(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--log=error', str(device)]
    status = _smartctl(argv)
    return {'log': status}

def selftestlog(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--log=selftest', str(device)]
    status = _smartctl(argv)
    return {'log': status}

def selectivelog(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--log=selective', str(device)]
    status = _smartctl(argv)
    return {'log': status}

def enable(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--smart=on', '--saveauto=on', str(device)]
    status = _smartctl(argv)
    return {'enable': status}

def disable(device=None, **kw):
    if device is None:
        raise NASError('Bad Request')
    argv = ['--smart=off', '--saveauto=off', str(device)]
    status = _smartctl(argv)
    return {'disable': status}

def _smartctl(argv):
    # argv = map(str, argv)
    argument = ['su', '-c', 'smartctl "%s"' % '" "'.join(argv)]
    (error, result) = POPEN(argument)
    status = result.read()
    result.close()
    if error != 0 and error != 32:
        raise NASError('System Error', status)
    return status

# vim: set sta sw=4 et:
