﻿$(function(){
	window.App="DiskManager";
	layout();
	loadLang();
	loadData();
	//bindEvent();

});


function layout(){
	window.Layout = $('body').layout({ 
			center__paneSelector:"#main" 
		,	north__paneSelector:"#top" 
		,	north__size:60
		,	north__spacing_open:0
		,	west__paneSelector:"#devicelist" 
		,	west__size:250
		,	west__spacing_open:5
		//,	contentSelector:".content"
		//,	center__onresize_end: function(){ }
	}); 	
	$('#graph').height(80);
	window.partitiongrid=$("#partitions table:first")[0];
	$(window.partitiongrid).flexigrid({
		singleSelect:true
		,colModel : [
			{display: '<label domain="l10n" msgid="DiskManager_text_Ppath"></label>', name : 'path', width : 100, sortable : false, align: 'left'}
			,{display: '<label domain="l10n" msgid="DiskManager_text_Pmount"></label>', name : 'mount', width : 100, sortable : false, align: 'left'}
			,{display: '<label domain="l10n" msgid="DiskManager_text_Plength"></label>', name : 'length', width : 60, sortable : false, align: 'left'}
			,{display: '<label domain="l10n" msgid="DiskManager_text_Pavailable"></label>', name : 'available', width : 60, sortable : false, align: 'left'}
			,{display: '<label domain="l10n" msgid="DiskManager_text_Pused"></label>', name : 'used', width : 60, sortable : false, align: 'left'}
			,{display: '<label domain="l10n" msgid="DiskManager_text_Ptype"></label>', name : 'type', width : 60, sortable : false, align: 'left', hide:true}
			,{display: '<label domain="l10n" msgid="DiskManager_text_Pfs"></label>', name : 'fs', width : 50, sortable : false, align: 'left', hide:true}
			,{display: '<label domain="l10n" msgid="DiskManager_text_Plabel"></label>', name : 'label', width : 100, sortable : false, align: 'left', hide:true}
			
		]
	});
	$('#REFRESH').click(function(){
		$("tr",window.partitiongrid).remove();
		loadData();
	});
}



function loadData(){
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/devices"
		,cache:false
		,data:{
			hash:window.top.SessionID
		}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}


function parseData(data, node){
	if(node)node=$(node).attr('path');
	$("#devicelist").html('<ul class="disklist" style="display:none;"></ul>');
	window.$TREE=$("#devicelist ul");
	var raids=[];
	$('device',data).each(function(){
		if($('>raid',this).length>0){
			raids.push($('>path',this).text());
		};
	});

	$('device',data).each(function(){
		if($('length:first',this).text()!='0'){
			var li=document.createElement("li");
			var a=document.createElement("a");
			a.data={		
				path:$(this).children('path').text()
				,serial:$(this).children('serial').text()
				,model:$(this).children('model').text()
				,connectiontype:$(this).children('connectiontype').text()
				,cylinder:$(this).children('cylinder').text()-0
				,head:$(this).children('head').text()-0
				,sector:$(this).children('sector').text()-0
				,length:$(this).children('length').text()-0
				,sectorsize:$(this).children('sectorsize').text()-0
				,partitions:$(this).children('partition')
				,raid:$(this).children('raid')
				,start:0
				,raidmember:$(this).children('raidmember').text()
				,type:$(this).children('type').text()
			};
			
			if($.inArray(a.data.raidmember,raids)>-1)$(a).addClass('raidlive');

			a.data.size=a.data.length*a.data.sectorsize;
			a.innerHTML=a.data.model; 
			a.className="device";
			if(a.data.raidmember!=='')$(a).addClass('raidpart');
			a.setAttribute('path',a.data.path)
			var ul=document.createElement("ul");
			var eul=document.createElement("ul");
			
			var l=a.data.length;
			var ps=a.data.partitions;
			
			
			for(var i=0;i<ps.length;i++){
				var p=$(ps[i])
				var pdata={		
					path:$('path',p).text()
					,available:$('available',p).text()
					,used:$('used',p).text()
					,usedpercent:($('usedpercent',p).text()===''?'0%':$('usedpercent',p).text()+'%')
					,label:$('label',p).text()
					,mountpoint:$('mountpoint',p)
					,mountpointtext:''
					,start:$('start',p).text()-0
					,end:$('end',p).text()-0
					,length:$('length',p).text()-0
					,type:$('type',p).text()
					,flags:$('flags',p).text()
					,fs:$('fs',p).text()
					,raidmember:$('raidmember',p).text()
					,device:a
				};

				
			
				if(pdata.type==='extended'){
					var extended_start=pdata.start;
					var extended_end=pdata.end;
				}
				
				pdata.size=pdata.length*pdata.device.data.sectorsize;
				var pli=document.createElement("li");
				var pa=document.createElement("a");
				pa.data=pdata;
				pa.innerHTML= ((pa.data.label=="")?pa.data.path : pa.data.label)+' '+formatBytes(pa.data.size);//+'('+pa.data.usedpercent+')';

				//??
				if($.inArray(pa.data.raidmember,raids)>-1)$(pa).addClass('raidlive');

				//if(data.type==='extended')pa.innerHTML='<label domain="l10n" msgid="DiskManager_text_extended>'+$.l10n.__('DiskManager_text_extended')+'</label>';
				if(pa.data.type==='extended')pa.innerHTML='Extended Partitions';
				pa.setAttribute('path',pa.data.path)
				$(pa).addClass(pa.data.type);
				if(pa.data.mountpoint.length>0){
					$(pa).addClass('mounted');
					$(pa.data.device).addClass('hasmounted');
					$(pa.data.mountpoint).each(function(){
						pa.data.mountpointtext += $(this).text()+","
					});
				}
				if(pa.data.fs==='swap'&&data.mountpointtext!=='')window.noswap=false;
				if(pa.data.fs!='')$(pa).addClass('formatted');
				if(pa.data.raidmember!==''){
					$(pa).addClass('raidpart');
					$(a).addClass('hasraidpartr');
				}
				if(a.data.raid.children().length>0)$(pa).addClass('raidpartition');
				if(pa.data.type==='logic'){
					$(pli).append(pa).appendTo(eul);
				}
				else{
					$(pli).append(pa).appendTo(ul);	
				}
				
				if(pa.data.type==='extended'){
					$(pa).after(eul);
				}
		}
		
			
			
		a.partitions=ul;		
		if(a.data.type!==''||a.data.model==='Linux Soft RAID'){//??
			$(li).append(a).append(ul).appendTo(window.$TREE);
		}
		else{			
			$(a).addClass('fail');
			$(li).append(a).append('<ul><li><a><span class="failed">Unknown Device!</span></a></li></ul>').appendTo(window.$TREE);
		}
		
	
		if(a.data.raid.children().length>0){
			$(a).addClass('raiddevice');
			if($('syncpercent',a.data.raid).length>0)$(a).append(' <span>[Rebuilding:'+$('syncpercent',a.data.raid).text()+']</span>')
			if(a.data.partitions.length>0)$(a).addClass('hasraidpartitions');
		}
		window.$TREE.treeview({add:$(li)});
		
	}		
	
		if(window.noswap)$('#noswap').show();
		else{$('#noswap').hide();}
	
		//收集自由空间
		
		if($('a.extended',ul).length>0){
			var ps_start=extended_start;//a.data.length;	
			var ps_end=extended_end;
			var $pe=$('a.logic',ul);
			if($pe.length>0){
				for(var i=0,pel=$pe.length;i<pel;i++){
					ps_end=$pe[i].data.start;
					if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){
						var fsli=document.createElement("li");
						var fsa=document.createElement("a");
						$(fsa)
							.addClass('freelogic')
							.attr('path','freelogic_'+ps_start)
							.html("Free Space");
						fsa.data={
							path:'freelogic_'+ps_start
							,type:'freelogic'
							,device:a
							,start:ps_start
							,length:ps_end-ps_start+1
							,size:(ps_end-ps_start+1)*a.data.sectorsize
							,sectorsize:a.data.sectorsize
							,available:(ps_end-ps_start+1)*a.data.sectorsize
							,used:''
							,usedpercent:''
							,label:''
							,mountpointtext:''
							,flags:''
							,fs:''
						}
						$(fsli).append(fsa).appendTo(eul);
						$($pe[i].parentNode).before(fsli);
					}
					ps_start=$pe[i].data.end+1;
					if(i===pel-1){
						ps_end=extended_end; 
						if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){	
							var fsli=document.createElement("li");
							var fsa=document.createElement("a");
							$(fsa)
								.addClass('freelogic')
								.attr('path','freelogic_'+ps_start)
								.html("Free Space");
							fsa.data={
								path:'freelogic_'+ps_start
								,type:'freelogic'
								,device:a
								,start:ps_start
								,length:ps_end-ps_start+1
								,size:(ps_end-ps_start+1)*a.data.sectorsize
								,sectorsize:a.data.sectorsize
								,available:(ps_end-ps_start+1)*a.data.sectorsize
								,used:''
								,usedpercent:''
								,label:''
								,mountpointtext:''
								,flags:''
								,fs:''
							}
							$(fsli).append(fsa).appendTo(eul);
						}
					}
				}
			}
			else{
				var fsli=document.createElement("li");
				var fsa=document.createElement("a");
				$(fsa)
					.addClass('freelogic')
					.attr('path','freelogic_'+ps_start)
					.html("Free logic["+(ps_end-ps_start+1)+']');
				fsa.data={
					path:'freelogic_'+ps_start
					,type:'freelogic'
					,device:a
					,start:ps_start
					,length:ps_end-ps_start+1
					,size:(ps_end-ps_start+1)*a.data.sectorsize
					,sectorsize:a.data.sectorsize
					,available:(ps_end-ps_start+1)*a.data.sectorsize
					,used:''
					,usedpercent:''
					,label:''
					,mountpointtext:''
					,flags:''
					,fs:''
				}
				$(fsli).append(fsa).appendTo(eul);
			}
		}
		
		var ps_start=0;//a.data.length;	
		var ps_end=a.data.length;
		var $pe=$('a.primary, a.extended',ul);
		if($pe.length>0){
			for(var i=0,pel=$pe.length;i<pel;i++){
				ps_end=$pe[i].data.start;
				if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){
					var fsli=document.createElement("li");
					var fsa=document.createElement("a");
					$(fsa)
						.addClass('freespace')
						.attr('path','freespace_'+ps_start)
						.html("Free Space");
					fsa.data={
						path:'freespace_'+ps_start
						,type:'freespace'
						,device:a
						,start:ps_start
						,length:ps_end-ps_start+1
						,size:(ps_end-ps_start+1)*a.data.sectorsize
						,sectorsize:a.data.sectorsize
						,available:(ps_end-ps_start+1)*a.data.sectorsize
						,used:''
						,usedpercent:''
						,label:''
						,mountpointtext:''
						,flags:''
						,fs:''
					}
					$(fsli).append(fsa).appendTo(ul);
					$($pe[i].parentNode).before(fsli);
				}
				ps_start=$pe[i].data.end+1;
				if(i===pel-1){
					ps_end=a.data.length;
					if(ps_end-ps_start>(8*1024*1024/a.data.sectorsize)){
						var fsli=document.createElement("li");
						var fsa=document.createElement("a");
						$(fsa)
							.addClass('freespace')
							.attr('path','freespace_'+ps_start)
							.html("Free Space");
						fsa.data={
							path:'freespace_'+ps_start
							,type:'freespace'
							,device:a
							,start:ps_start
							,length:ps_end-ps_start+1
							,size:(ps_end-ps_start+1)*a.data.sectorsize
							,sectorsize:a.data.sectorsize
							,available:(ps_end-ps_start+1)*a.data.sectorsize
							,used:''
							,usedpercent:''
							,label:''
							,mountpointtext:''
							,flags:''
							,fs:''
						}
						$(fsli).append(fsa).appendTo(ul);
					}
				}
			}
		}
		else{	
			var fsli=document.createElement("li");
			var fsa=document.createElement("a");
			$(fsa)
				.addClass('freespace')
				.attr('path','freespace_'+ps_start)
				.html("Free Space");
			fsa.data={
				path:'freespace_'+ps_start
				,type:'freespace'
				,device:a
				,start:ps_start
				,length:ps_end-ps_start+1
				,size:(ps_end-ps_start+1)*a.data.sectorsize
				,sectorsize:a.data.sectorsize
				,available:(ps_end-ps_start+1)*a.data.sectorsize
				,used:''
				,usedpercent:''
				,label:''
				,mountpointtext:''
				,flags:''
				,fs:''
			}
			$(fsli).append(fsa).appendTo(ul);
		}
		
	});
	
	$(' a.freespace',$('a.device.raidpart',$TREE).next()).parent().remove();//??隐藏raidpart的freespace


	$('a.device',window.$TREE).each(function(){
		var table=document.createElement('table');
		var d=this.data;
		var html='<tbody><tr><td width="80" valign="top"><img src="icons/'+(this.data.connectiontype||this.data.type)+'.png" width="72" height="72"/></td><td><table>'
                +'<tr><th domain="l10n" msgid="DiskManager_text_Dmodel" style="text-align:left;"></th></tr><tr><td>'+d.model+'</td></tr>'
		//+'<tr><th domain="l10n" msgid="DiskManager_text_Dserial" style="text-align:left;"></th></tr><tr><td>'+d.serial+'</td></tr>'
                +'<tr><th domain="l10n" msgid="DiskManager_text_Dpath" style="text-align:left;"></th></tr><tr><td>'+d.path+'</td></tr>'
                +'<tr><th domain="l10n" msgid="DiskManager_text_Dlength" style="text-align:left;"></th></tr><tr><td>'+formatBytes(d.size)+'</td></tr>';
		if(d.raid&&d.raid.length>0){
			html += '<tr><th style="text-align:left;">RAID ('+$('level',d.raid).text()+')</th></tr>';
			$('>raiddevice',d.raid).each(function(){
				html += '<tr><td>'+$(this).text()+'</td></tr>';
			});
		}
		html +='</table></td></tr></tbody>';
		table.width="100%";
		table.className='param';
		table.node=this;
		$('#devicelist').append( table ).append('<hr/>');
		$(table).html(html);
	});
	$('#devicelist > table').click(function(){
			$('#devicelist table.selected').removeClass('selected');
			$(this).addClass('selected');
			showTable(this.node);
			//showPartitionMap(this.node);
	}).click();
	setLang({el: $('#devicelist')});
	//$('#devicelist > table').each(function(){$(this).click();});
	
}


function showTable(n){
	var $n=$(n);
	if($n.hasClass('listed'))return;
	$n.addClass('listed');
	var data=n.data;
	if(!data)return;
	$('ul a',$n.parent()).each(function(){
		var d=this.data;
		if(!d)return;
		if(d.fs!=='swap'&&d.type!=='freespace')	{
		window.partitiongrid.grid.addRow({
			id:d.path.replace(/\//g,'')
			,length:formatBytes(d.size)
			,available:formatBytes(d.available)
			,used:formatBytes(d.used)
			,path:d.path
			,label:d.label
			,mount:d.mountpointtext
			,type:d.type
			,fs:d.fs
		});
		}
	});
	window.partitiongrid.grid.Resize();
}

