﻿(function($){
	$.addFlex = function(t,p)
	{
		if (t.grid) return false; //return if already exist		
		// apply default properties
		p = $.extend({
			inPlaceSort: true 
			,height: 'auto' //default height
			,width: 'auto' //auto width
			,striped: true //apply odd even stripes
			,minwidth: 50 //min width of columns
			,minheight: 20 //min height of columns
			,resizable: true //resizable table
			,url: false //ajax url
			,method: 'GET' // data sending method
			,dataType: 'xml' // type of data loaded
			,errormsg: 'Connection Error!'
			,usepager: false //
			,nowrap: true //
			,page: 1 //current page
			,total: 1 //total pages
			,useRp: true //use the results per page select box
			,rp: 40 // results per page
			,rpOptions: [20,40,60,80,100]
			,title: false
			,pagestat: '{total} items, {from} to {to}'
			,procmsg: 'Processing...'
			,query: ''
			,qtype: ''
			,sortorder:'desc'
			,localsortorder:'desc'
			,nomsg: 'No data'
			,minColToggle: 1 //minimum allowed column to be hidden
			,showToggleBtn: true //show or hide column toggle popup
			,hideOnSubmit: true
			,autoload: true
			,blockOpacity: 0.5
			,onToggleCol: false
			,onChangeSort: false
			,onSuccess: false
			,onSubmit: false // using a custom populate function
			,onRowSelected: false //加上行的动作,ding
		 	,onRowDeselected: false //加上行的动作,ding
		}, p);
		$(t)
			.show() 
			.attr({cellPadding: 0, cellSpacing: 0, border: 0})  
			.removeAttr('width');		
		//create grid class
		var g = {
			hset : {},

			//设置cDrag位置
			rePosDrag: function () {
				var cdleft = 0 - this.hDiv.scrollLeft;
				if (this.hDiv.scrollLeft>0) cdleft -= Math.floor(p.cgwidth/2);				
				var cdpad = this.cdpad;	
				$('div',g.cDrag).hide();			
				$("thead tr:first th[hide!='true']",g.hDiv).each(function (){
						var n = $('thead tr:first th:visible',g.hDiv).index(this);
	
						var cdpos = parseInt($('div',this).width());
	
						var ppos = cdpos;
						if (cdleft==0) cdleft -= Math.floor(p.cgwidth/2);
						cdpos = cdleft + (cdpos + cdpad);
						cdleft = cdpos;
						$('div:eq('+n+')',g.cDrag).css({left:cdleft+'px', height:$(g.hDiv).height()-2}).show();
				
				});
			},

			//重置表格高度
			fixHeight: function (newH) {
					newH = false;
					if (!newH) newH = this.bDiv.scrollHeight;
					var nd = parseInt($(g.nDiv).height());
					if (nd>newH)
						$(g.nDiv).height(newH).width(200);
					else
						$(g.nDiv).height('auto').width('auto');	
					$(g.block).css({height:newH,marginBottom:(newH * -1)});	
					var hrH = g.bDiv.offsetTop + newH;
					$(g.rDiv).css({height: hrH});
				
			},

			//拖拽表头开始
			dragStart: function (dragtype,e,obj) { //default drag function start	
				//column resize			
				if (dragtype=='colresize') {
					$(g.nDiv).hide();$(g.nBtn).hide();
					var n = $('div',this.cDrag).index(obj);
					var ow = $('th:visible div:eq('+n+')',this.hDiv).width();
					$(obj).addClass('dragging').siblings().hide();
					$(obj).prev().addClass('dragging').show();
					this.colresize = {startX: e.pageX, ol: parseInt(obj.style.left), ow: ow, n : n };
					$('body').css('cursor','col-resize');
				}//column header drag				
				else if (dragtype=='colMove') {
					$(g.nDiv).hide();$(g.nBtn).hide();
					this.hset = $(this.hDiv).offset();
					this.hset.right = this.hset.left + $('table',this.hDiv).width();
					this.hset.bottom = this.hset.top + $('table',this.hDiv).height();
					this.dcol = obj;
					this.dcoln = $('th',this.hDiv).index(obj);
					this.colCopy = document.createElement("div");
					this.colCopy.className = "colCopy";
					this.colCopy.innerHTML = obj.innerHTML;
					if ($.browser.msie){this.colCopy.className = "colCopy ie";}
					$(this.colCopy).css({position:'absolute',float:'left',display:'none', textAlign: obj.align});
					$('body').append(this.colCopy);
					$(this.cDrag).hide();
				}
				$('body').noSelect();
			},

			//拖拽表头移动
			dragMove: function (e) {
				//column resize
				if (this.colresize) {
					var n = this.colresize.n;
					var diff = e.pageX-this.colresize.startX;
					var nleft = this.colresize.ol + diff;
					var nw = this.colresize.ow + diff;
					if (nw > p.minwidth){
						$('div:eq('+n+')',this.cDrag).css('left',nleft);
						this.colresize.nw = nw;
						}
				}
				else if (this.colCopy) {
					$(this.dcol).addClass('thMove').removeClass('thOver'); 
					if (e.pageX > this.hset.right || e.pageX < this.hset.left || e.pageY > this.hset.bottom || e.pageY < this.hset.top){
						//this.dragEnd();
						$('body').css('cursor','move');
					}
					else  $('body').css('cursor','pointer');
					$(this.colCopy).css({top:e.pageY + 10,left:e.pageX + 20, display: 'block'});
				}
			
			},

			//拖拽表头结束
			dragEnd: function () {
				if (this.colresize){
					var n = this.colresize.n;
					var nw = this.colresize.nw;
					$('th:visible div:eq('+n+')',this.hDiv).css('width',nw);
					$('tr',this.bDiv).each (function (){
						$('td:visible > div:eq('+n+')',this).css('width',nw);
					});
					this.hDiv.scrollLeft = this.bDiv.scrollLeft;
					$('div:eq('+n+')',this.cDrag).siblings().show();
					$('.dragging',this.cDrag).removeClass('dragging');
					this.rePosDrag();
					this.fixHeight();
					this.colresize = false;
				}
				else if (this.colCopy){
					$(this.colCopy).remove();
					if (this.dcolt != null){							
						if (this.dcoln>this.dcolt)
							$('th:eq('+this.dcolt+')',this.hDiv).before(this.dcol);
						else
							$('th:eq('+this.dcolt+')',this.hDiv).after(this.dcol);
						this.switchCol(this.dcoln,this.dcolt); 
						$(this.cdropleft).remove();
						$(this.cdropright).remove();
						this.rePosDrag();
					}
					this.dcol = null;
					this.hset = null;
					this.dcoln = null;
					this.dcolt = null;
					this.colCopy = null;
					$('.thMove',this.hDiv).removeClass('thMove');
					$(this.cDrag).show();
				}
				$('body').css('cursor','default');
			},

			//切换到列
			toggleCol: function(cid,visible) {
				var ncol = $("th[axis='col"+cid+"']",this.hDiv)[0];
				var n = $('thead th',g.hDiv).index(ncol);
				var cb = $('input[value='+cid+']',g.nDiv)[0];
				if (visible==null){
					visible = ncol.hide;
				}				
				if ($('input:checked',g.nDiv).length<p.minColToggle&&!visible) return false;
				if (visible){
					ncol.hide = false;
					$(ncol).show();
					cb.checked = true;
				}
				else{
					ncol.hide = true;
					$(ncol).hide();
					cb.checked = false;
				}
				$('tr',t).each(function (){
					if (visible)
						$('td:eq('+n+')',this).show();
					else
						$('td:eq('+n+')',this).hide();
				});
				this.rePosDrag();
				if (p.onToggleCol) p.onToggleCol(cid,visible);
				return visible;
			},

			//交换列 //switch columns
			switchCol: function(cdrag,cdrop) { 
				$('tr',t).each(function (){ 
					if (cdrag>cdrop)
						$('td:eq('+cdrop+')',this).before($('td:eq('+cdrag+')',this));
					else
						$('td:eq('+cdrop+')',this).after($('td:eq('+cdrag+')',this));
				});
				if (cdrag>cdrop)
					$('tr:eq('+cdrop+')',this.nDiv).before($('tr:eq('+cdrag+')',this.nDiv));
				else
					$('tr:eq('+cdrop+')',this.nDiv).after($('tr:eq('+cdrag+')',this.nDiv));	
				this.hDiv.scrollLeft = this.bDiv.scrollLeft;
			},

			//丁 设置表格背景随滚动条滚动，解决错位
			scroll: function() {
				g.bDiv.style.backgroundPosition = "0 -"+this.bDiv.scrollTop+"px";
				g.hDiv.scrollLeft = g.bDiv.scrollLeft;
				g.rePosDrag();
				if(p.transfrom){
					p.transfrom.$list[0].scrollTop = g.bDiv.scrollTop;
				}
			},
			

			//设置表头数据
			setValue:function(content){
				var row=content.row;
				var data=content.data;
				$('thead tr:first th',g.hDiv).each(function(){
					if(data[this.getAttribute("name")]!=undefined){
						$('td[_name='+this.getAttribute("name")+'] > div:first',row).html(data[this.getAttribute("name")]);
					}
				});	
			},


			//表头排序
			sortColumn: function(){
				var keepFirst = false;
				if($('thead tr:first th:eq(0)').attr('name') === '__CHECKBOX')keepFirst = true;				
				for(var i=0; i < p.cols.length; i++){
					var th = $('thead tr:first th[abbr='+p.cols[i]+']',g.hDiv);
					var coln = $('thead tr:first th').index(th);
					if(coln == i+1)continue;
					if(keepFirst)
						$('thead tr:first th:eq('+i+')').after(th);
					else
						$('thead tr:first th:eq('+i+')').before(th);
					$('tr:eq('+i+')',g.nDiv).after($('tr:eq('+coln+')',g.nDiv));
					$('tr',g.bDiv).each(function (){
						$('td:eq('+i+')',this).after($('td:eq('+coln+')',this));
					});
					g.rePosDrag();
				}
			},
			
			
			//列排序change sortorder
			changeSort: function(th,m) {
				if (g.loading) return true;
				$(g.nDiv).hide();$(g.nBtn).hide();
				if(p.transfrom){
					p.transfrom.g.sorts({sortby:$(th).attr('name') });
				}else{				
					if (p.localsortname === $(th).attr('name')){ 
						if (p.localsortorder.toLowerCase()=='asc') p.localsortorder = 'desc'; 
						else p.localsortorder = 'asc'; 
					}
					$(th).addClass('localsorted').siblings().removeClass('localsorted');
					p.localsortname= $(th).attr('name');
					if(p.transfrom){
						p.transfrom.sortby=p.localsortname;
						p.transfrom.sortorder=p.localsortorder;
					}
					g.inPlaceSort();
				}
			},

			
			
			//本地排序jquery sort
			inPlaceSort: function() {
				var sortname=p.localsortname;
				var sortorder=p.localsortorder;
			    	var stripChar = function(s, c) {
					var r = "";
					for(var i = 0; i < s.length; i++) {
						r += c.indexOf(s.charAt(i))>=0 ? "" : s.charAt(i);
					}
					return r;
			   	 }			
			    	var isNumeric = function(s) {
					var valid = "0123456789.,- ";
					var result = true;
					var c;
					for(var i = 0; i < s.length && result; i++) {
						c= s.charAt(i);
						if(valid.indexOf(c) <= -1) {
							result = false;
						}
					}
			    		return result;
			    	}
			   	col = $(g.hDiv).find("th").index($(g.hDiv).find("th[name='"+sortname+"']"));
			    	if (isNaN(col) || col < 0) {
			        	alert("Sorting is somehow not configured properly - couldn't find the header for name '"+sortname+"'");
			    	}
			    	var rows = $(g.bDiv).find("tr");
			   	if (!rows || rows.length < 2) {
			    		return;
			    	}			    
			    	var parent = $(rows[0]).parent();
			   	rows.sort(function(a, b) {
			      		var keyA = $(sortorder == 'asc' ? a : b).children("td").eq(col).text();
			      		var keyB = $(sortorder == 'asc' ? b : a).children("td").eq(col).text();
			      		if((isNumeric(keyA)||keyA.length<1) && (isNumeric(keyB)||keyB.length<1)) {
			        		keyA = stripChar(keyA,", ");
			        		keyB = stripChar(keyB,", ");
			        		if(keyA.length < 1) keyA = 0;
			        		if(keyB.length < 1) keyB = 0;
			        		keyA = new Number(parseFloat(keyA));
			        		keyB = new Number(parseFloat(keyB));
			      		}
			      		return keyA>keyB ? 1 : keyA<keyB ? -1 : 0;
			    	});
			    	$.each(rows, function(i,tr) {
			    		if (i % 2 && p.striped) 
			    			$(tr).addClass('erow');
			    		else
			    			$(tr).removeClass('erow');
			    		$('td',$(tr)).each(function(n,td){
			    			if(n==col)
			    				$(td).addClass('sorted');
			    			else
			    				$(td).removeClass('sorted');
			    		});
			        	$(parent).append(tr);
			    	});
			},


			



			//生成
			populate: function () { //get latest data
				if (g.loading) return true;
				g.loading = true;				
			},



			//刷新
			doRefresh: function (param) { 
				g.populate();				
			},



			//添加表格属性
			addCellProp: function (tr){
				var $TD=(tr)?$('td',tr):$('tr td',g.bDiv);
				$TD.each(function (){
					var tdDiv = document.createElement('div');
					var n = $('td',$(this).parent()).index(this);
					var pth = $('th:eq('+n+')',g.hDiv).get(0);
					if (pth!=null){
						if (p.sortname==$(pth).attr('abbr')&&p.sortname) {
							this.className = 'sorted';
						}
						$(tdDiv).css({textAlign:pth.align,width: $('div:first',pth)[0].style.width});
						if (pth.hide) $(this).css('display','none');
					}
					if (p.nowrap==false) $(tdDiv).css('white-space','normal');
					//if (this.innerHTML=='') this.innerHTML = '&nbsp;'; 丁 去掉&nbsp;显示
					//tdDiv.value = this.innerHTML; //store preprocess value
					tdDiv.innerHTML = this.innerHTML;
					var prnt = $(this).parent()[0];
					var pid = false;
					if (prnt.id) pid = prnt.id.substr(3);
					if (pth!=null) {
						if (pth.process) pth.process(tdDiv,pid);
					}
					$(this).empty().append(tdDiv).removeAttr('width'); //wrap content
					//add editable event here 'dblclick' 此处可加入双击事件
				});
					
			},



			//添加行属性 单击/鼠标按下/鼠标抬起/鼠标经过
			addRowProp: function(tr){
				var $TR=(tr)?$(tr):$('tr',g.bDiv);
				$TR.each(function (){
					$(this)
						.mousedown(function (e) {
							var obj = (e.target || e.srcElement); if (obj.href || obj.type) return true;
							if(e.which===1){//左键
								$(this).toggleClass('trSelected');
								if (p.singleSelect){
									$(this).siblings().removeClass('trSelected');
								}else{
									if(!e.ctrlKey&&!$(obj).hasClass('checkbox')){
										$(this).siblings().removeClass('trSelected');
									}
									if(e.shiftKey){
										if(t.$LASTCLICKED){
											$('tr',t).removeClass('trSelected');
											$(this).addClass('clicked');
											t.$LASTCLICKED.addClass('trSelected');
											if(t.$LASTCLICKED.nextAll().hasClass('clicked'))t.$LASTCLICKED.nextUntil('tr.clicked').addClass('trSelected');
											if(t.$LASTCLICKED.prevAll().hasClass('clicked'))t.$LASTCLICKED.prevUntil('tr.clicked').addClass('trSelected');
											$(this).removeClass('clicked').addClass('trSelected');
										}
									}
									if(!e.shiftKey)t.$LASTCLICKED=$(this);
								}
							}
							if(e.which===3){
								if(!$(this).hasClass('trSelected')){
									$(this).siblings().removeClass('trSelected');
									$(this).addClass("trSelected");
								}
							}
						}).dblclick(function (e){
							$(this.original).dblclick();
						});
				});
			},




			//丁 自适应
			Resize:	function(){
				window.setTimeout ( function() {
					$(g.bDiv).height($(g.gDiv).height()-$(g.tDiv).height()-$(g.hDiv).height()-$(g.pDiv).height());
					g.rePosDrag();
					if(p.transfrom){
						var h=(g.bDiv.scrollWidth>$(g.bDiv).width())?$(g.bDiv).height()-16:$(g.bDiv).height();
						$(p.transfrom.$list).height(h);
						p.transfrom.$list[0].scrollTop = g.bDiv.scrollTop;
					}
				}, 300);
			},





			//丁 回到00
			scrollTo0:function(){
				g.bDiv.scrollTop=0;
				g.bDiv.scrollLeft=0;
				g.scroll();
			},

			
			//丁 获取选中行id
			getSelected:function(){
				var a=[];
				$("tr.trSelected",g.bDiv).each(function(){
					a.push(this.id);	
				});
				return a;
			},

			
			//丁 获取选中行指定列的数值，输入一个数组，返回一个对象 {trid:{col1:,col2:},trid2:{col1:,col2:}}
			getSelectedValue:function(c){
				var r={};				
				$("tr.trSelected",g.bDiv).each(function(){
					r[this.id]=[];
					for(var i=0,l=c.length;i<l;i++){
						r[this.id][c[i]]=g.getTrData(this)[c[i]];
					}
				});
				return r;
			},


			//获取行数据 丁:需要调整
			getTrData:function(tr){
				var tds=$("td",tr);
				var r={};
				r.id=tr.id;
				for (var i=0;i<tds.length;i++){
					r[tds[i].header.name]=tds[i].value;
				}
				return r;
			},

			//生成表头
			setHeader:function(){
				if (p.colModel){
					thead = document.createElement('thead');
					tr = document.createElement('tr');
					for (i=0;i<p.colModel.length;i++){
						var cm = p.colModel[i];
						var th = document.createElement('th'); 
						if(i===0) th.innerHTML = cm.display ;
						else th.innerHTML = cm.display;
						$(th).attr('name',cm.name).attr('abbr',cm.name).addClass('sortable');
						//th.idx = i;
						$(th).attr('axis','col'+i);
						th.name=p.colModel[i].name;
						//if (cm.align)th.align = cm.align;
						if (cm.width) $(th).attr('width',cm.width);
						if (cm.hide)th.hide = true;
						if (cm.process)th.process = cm.process;	
						$(tr).append(th);
					}
					$(thead).append(tr);
					$(g.hTable).append(thead);
					setLang({el:$(thead)})
					if(!p.singleSelect){
						var $s=$('.checkbox',g.hTable); 
						$s.parent().click(function(){
							var $s=$('.checkbox',g.hTable).removeClass('partial').toggleClass('checked');
							if($s.hasClass('checked')){
								$('tr',g.bDiv).addClass('trSelected');
							}
							else{
								$('tr',g.bDiv).removeClass('trSelected');
							}
						});
					}
				}
				$('thead tr:first th',g.hDiv).each(function (){
					var thdiv = document.createElement('div');
					$(this).mousedown(function (e) {// 丁
						if (!$(this).hasClass('thOver')) return false;
						var obj = (e.target || e.srcElement);
						if(obj.href || obj.type) return true; 
						g.changeSort(this);
						return false;
					});
					if ($(this).attr('name')){							
						if ($(this).attr('name')==p.sortname){
							this.className = 'sorted';
							thdiv.className = 's'+p.sortorder;
						}
					}			
					if (this.hide) $(this).hide();
					if (!p.colmodel){
						$(this).attr('axis','col' + ci++);
					}
					$(thdiv).css({textAlign:this.align, width: this.width + 'px'});
					thdiv.innerHTML = this.innerHTML;
					$(this)
						.empty().append(thdiv).removeAttr('width')
						.mousedown(function (e) {
							g.dragStart('colMove',e,this);
						}).hover(function(){
							if (!g.colresize&&!$(this).hasClass('thMove')&&!g.colCopy) $(this).addClass('thOver');
							if ($(this).attr('abbr')!=p.sortname&&!g.colCopy&&!g.colresize&&$(this).attr('abbr')) $('div',this).addClass('s'+p.sortorder);
							else if ($(this).attr('abbr')==p.sortname&&!g.colCopy&&!g.colresize&&$(this).attr('abbr')){
								var no = '';
								if (p.sortorder=='asc') no = 'desc';
								else no = 'asc';
								$('div',this).removeClass('s'+p.sortorder).addClass('s'+no);
							}								
							if (g.colCopy) {
								var n = $('th',g.hDiv).index(this);									
								if (n==g.dcoln) return false;
								if (n<g.dcoln) $(this).append(g.cdropleft);
								else $(this).append(g.cdropright);
								g.dcolt = n;
							}
							else if (!g.colresize) {										
								var nv = $('th:visible',g.hDiv).index(this);
								var onl = parseInt($('div:eq('+nv+')',g.cDrag).css('left'));
								var nw = parseInt($(g.nBtn).width()) + parseInt($(g.nBtn).css('borderLeftWidth'));
								nl = onl - nw + Math.floor(p.cgwidth/2);									
								$(g.nDiv).hide();$(g.nBtn).hide();									
								$(g.nBtn).css({'left':nl,top:g.hDiv.offsetTop}).show();									
								var ndw = parseInt($(g.nDiv).width());									
								$(g.nDiv).css({top:g.hDiv.offsetTop+1,width:"auto",height:"auto"});									
								if ((nl+ndw)>$(g.gDiv).width())
									$(g.nDiv).css('left',onl-ndw+1);
								else
									$(g.nDiv).css('left',nl);										
								if ($(this).hasClass('sorted')) 
									$(g.nBtn).addClass('srtd');
								else
									$(g.nBtn).removeClass('srtd');										
							}							
						},function(){
								$(this).removeClass('thOver');
								if ($(this).attr('abbr')!=p.sortname) $('div',this).removeClass('s'+p.sortorder);
								else if ($(this).attr('abbr')==p.sortname){
									var no = '';
									if (p.sortorder=='asc') no = 'desc';
									else no = 'asc';
									$('div',this).addClass('s'+p.sortorder).removeClass('s'+no);
								}
								if (g.colCopy) {								
									$(g.cdropleft).remove();
									$(g.cdropright).remove();
									g.dcolt = null;
								}
							}
						); //wrap content
					});
					var cdcol = $('thead tr:first th:first',g.hDiv).get(0);		
					if (cdcol != null){		
						g.cDrag.className = 'cDrag';
						g.cdpad = 0;			
						g.cdpad += (isNaN(parseInt($('div',cdcol).css('borderLeftWidth'))) ? 0 : parseInt($('div',cdcol).css('borderLeftWidth'))); 
						g.cdpad += (isNaN(parseInt($('div',cdcol).css('borderRightWidth'))) ? 0 : parseInt($('div',cdcol).css('borderRightWidth'))); 
						g.cdpad += (isNaN(parseInt($('div',cdcol).css('paddingLeft'))) ? 0 : parseInt($('div',cdcol).css('paddingLeft'))); 
						g.cdpad += (isNaN(parseInt($('div',cdcol).css('paddingRight'))) ? 0 : parseInt($('div',cdcol).css('paddingRight'))); 
						g.cdpad += (isNaN(parseInt($(cdcol).css('borderLeftWidth'))) ? 0 : parseInt($(cdcol).css('borderLeftWidth'))); 
						g.cdpad += (isNaN(parseInt($(cdcol).css('borderRightWidth'))) ? 0 : parseInt($(cdcol).css('borderRightWidth'))); 
						$(g.bDiv).before(g.cDrag); 			
						var cdheight = $(g.bDiv).height();
						var hdheight = $(g.hDiv).height();
						//丁 cDrag的位置			
						$(g.cDrag).css({top:g.hDiv.offsetTop+"px",overflow:"visible"}); 
						$('thead tr:first th',g.hDiv).each(function (){
							var cgDiv = document.createElement('div');
							$(g.cDrag).append(cgDiv);
							if (!p.cgwidth) p.cgwidth = $(cgDiv).width();
							//丁 cDrag div 的高度
							$(cgDiv)
								.css({height: (hdheight-2)+"px" })
								.mousedown(function(e){g.dragStart('colresize',e,this);});
						});
						//g.rePosDrag();
					}
					// add column control
					if ($('th',g.hDiv).length){
						g.nDiv.className = 'nDiv';
						g.nDiv.innerHTML = "<table cellpadding='0' cellspacing='0'><tbody></tbody></table>";
						$(g.nDiv)
							.css({
								marginBottom: (gh * -1)
								,'display': 'none'
								//top: gtop
							});
						var cn = 0;
						$('th div',g.hDiv).each(function (){
							var kcol = $("th[axis='col" + cn + "']",g.hDiv)[0];
							var chk = 'checked="checked"';
							if (kcol.style.display=='none') chk = '';
							$('tbody',g.nDiv).append('<tr><td class="ndcol1"><input type="checkbox" '+ chk +' class="togCol" value="'+ cn +'" /></td><td class="ndcol2">'+this.innerHTML+'</td></tr>');
							cn++;
						});
						$('td.ndcol2',g.nDiv).click(function (){
							if ($('input:checked',g.nDiv).length<=p.minColToggle&&$(this).prev().find('input')[0].checked) return false;
							return g.toggleCol($(this).prev().find('input').val());
						});			
						$('input.togCol',g.nDiv).click(function (){
							if ($('input:checked',g.nDiv).length<p.minColToggle&&this.checked==false) return false;
							$(this).parent().next().trigger('click');
							//return false;
						});
						$(g.gDiv).prepend(g.nDiv);
						$(g.nBtn).addClass('nBtn')
							.html('<div></div>')
							.attr('title','Hide/Show Columns')
							.click(function (){
								$(this).hide();
			 					$(g.nDiv).toggle();
								return true;
							});			
						if (p.showToggleBtn) $(g.gDiv).prepend(g.nBtn);
					}
		
					g.rePosDrag();
					g.fixHeight();		
				},

			


			//添加行
			addRow:function(content,original,nobind){
				var tr=document.createElement("tr");
				if(content.id)tr.id=content.id;
				$('thead tr:first th',g.hDiv).each(function(){
					var td=document.createElement("td");
					td._name=this.getAttribute("name");
					tr.appendChild(td);
					td.innerHTML=content[td._name];
					td.setAttribute('_name',td._name);
				});
				if($('tbody:first',t).length==0)$(t).append('<tbody/>');
				$('tbody:first',t).append(tr);
				if(!nobind){
					g.addCellProp(tr);
					g.addRowProp(tr);
					g.rePosDrag();
				}
				tr.getData=function(){return content;}
				if(original){
					tr.original=original;
					if($(original).hasClass('selected'))$(tr).addClass('trSelected');
				}
				return tr;
			},


			getSelectedRows:function(){
				return $('tr.trSelected',t);
			},



			//默认pager
			pager: 0			
		};//g 结束		
		//create model if any
		//init divs
		g.gDiv = document.createElement('div'); //create global container
		g.hDiv = document.createElement('div'); //create header container
		g.bDiv = document.createElement('div'); //create body container
		g.rDiv = document.createElement('div'); //create horizontal resizer
		g.cDrag = document.createElement('div'); //create column drag
		g.block = document.createElement('div'); //creat blocker
		g.nDiv = document.createElement('div'); //create column show/hide popup
		g.nBtn = document.createElement('div'); //create column show/hide button
		g.tDiv = document.createElement('div'); //create toolbar
		g.sDiv = document.createElement('div');		
		g.pDiv = document.createElement('div'); //create pager container
		g.hTable = document.createElement('table');
		
		//set gDiv
		g.gDiv.className = 'flexigrid';
		g.gDiv.cssText="width:100%;height:100%;";
		if ($.browser.msie)$(g.gDiv).addClass('ie');
		$(t).before(g.gDiv);
		$(g.gDiv)
		.append(t);

		
		//set hDiv
		g.hDiv.className = 'hDiv';
		$(t).before(g.hDiv);
		g.hTable.cellPadding = 0;
		g.hTable.cellSpacing = 0;
		$(g.hDiv).append('<div class="hDivBox"></div>');
		$('div',g.hDiv).append(g.hTable);		
		if (!p.colmodel) var ci = 0;
		
		//set bDiv
		g.bDiv.className = 'bDiv';
		g.bDiv.style.cssText="overflow:auto;";
		$(t).before(g.bDiv);
		$(g.bDiv)
		.css({ height: "100%"})
		.scroll(function (e) {g.scroll();})
		.append(t);
		
		g.addCellProp();
		g.addRowProp();

		//setup cdrops
		g.cdropleft = document.createElement('span');
		g.cdropleft.className = 'cdropleft';
		g.cdropright = document.createElement('span');
		g.cdropright.className = 'cdropright';

		//add block
		g.block.className = 'gBlock';
		var gh = $(g.bDiv).height();
		var gtop = g.bDiv.offsetTop;
		$(g.block).css({
			width: g.bDiv.style.width,
			height: gh,
			background: 'white',
			position: 'relative',
			marginBottom: (gh * -1),
			zIndex: 1,
			top: gtop,
			left: '0px'
		});
		$(g.block).fadeTo(0,p.blockOpacity);

		
		// add flexigrid events
		$(g.bDiv).hover(function(){$(g.nDiv).hide();$(g.nBtn).hide();},function(){if (g.multisel) g.multisel = false;});
		$(g.gDiv).hover(function(){},function(){$(g.nDiv).hide();$(g.nBtn).hide();});
		
		//add document events
		$(document)
		.mousemove(function(e){g.dragMove(e)})
		.mouseup(function(e){g.dragEnd()})
		.hover(function(){},function (){g.dragEnd()});
		
		//make grid functions accessible
		t.p = p;
		t.grid = g;
		
		// load data
		g.setHeader();
		$(window).resize(function(){g.Resize();});
		return g;		
			
	};

	//main
	var docloaded = false;
	$(document).ready(function () {docloaded = true} );
	$.fn.flexigrid = function(p) {
		return this.each( function() {
			if (!docloaded){
				$(this).hide();
				var t = this;
				$(document).ready(function (){
					$.addFlex(t,p);
				});
			} else {
				$.addFlex(this,p);
			}
		});

	}; 

	$.fn.noSelect=function(p){
		if(p==null)prevent=true;
		else prevent=p;
		if(prevent){
			return this.each(function(){
				if($.browser.msie||$.browser.safari)$(this).bind('selectstart',function(){return false;});
				else if($.browser.mozilla){$(this).css('MozUserSelect','none');$('body').trigger('focus');}
				else if($.browser.opera)$(this).bind('mousedown',function(){return false;});
				else $(this).attr('unselectable','on');
			});
		}else{
			return this.each(function(){
				if($.browser.msie||$.browser.safari)$(this).unbind('selectstart');
				else if($.browser.mozilla)$(this).css('MozUserSelect','inherit');
				else if($.browser.opera)$(this).unbind('mousedown');
				else $(this).removeAttr('unselectable','on');
			});
		}
	};

})(jQuery);
